## Script (Python) "AsxGen.asx"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=servinfoid=None, REQUEST=None
##title=
##
#context.writelog('AsxGen', 'AsxGen called')
if not REQUEST:
    REQUEST = context.REQUEST

req = REQUEST
mm = context.portal_medianet
event = mm.getEventFor(context)

#context.writelog('Asx Gen', 'Server info id is %s' % servinfoid)
serverinfo = mm.getServerinfoFor(context, req)

isLive = mm.isLive(context)
isEvent = context.meta_type == 'Media Manager Event'
#context.writelog('AsxGen', 'Is this an event? %d' % isEvent)

def getStart(title, author, rights):
    start = """<ASX version="3.0">
    <TITLE>%s</TITLE>
    <AUTHOR>%s</AUTHOR>
    <COPYRIGHT>%s</COPYRIGHT>
    """ % (title, author, rights)
    return start

def getEnd():
    end = """</ASX>"""
    return end

def getLiveEntry(title, ref):
    entry = """
    <Entry>
     <TITLE>%s</TITLE>
     <REF href="%s" />
    </Entry>
    """ % (title, ref)
    return entry

def getArchiveEntry(title, starttime, duration, ref):
    entry = """
    <Entry>
     <TITLE>%s</TITLE>
     <starttime value="%s" />
     <duration value="%s" />
     <Ref href="%s" />
    </Entry>
    """ % (title, starttime, duration, ref)
    return entry

req.RESPONSE.setHeader('Content-Type', 'video/x-ms-asf')

if isLive:
    url = mm.getCinemaUrlFor(context, req, serverinfo)
    start = getStart(event.title, event.Creator(), DateTime().strftime('%Y'))
    entry = getLiveEntry(context.title, url)
    end = getEnd()
    #context.writelog('AsxGen', 'Start is:\n%s' % start)
    #context.writelog('AsxGen', 'Entry is:\n%s' % entry)
    #context.writelog('Asx Gen', 'End is:\n%s' % end)
    print start
    print entry
    print end
    return printed
else:
    start = getStart(event.title, event.Creator(), DateTime().strftime('%Y'))
    url = mm.getCinemaUrlFor(context, req)
    if isEvent:
        entries = []
        for clip in context.listClips():
            entry = getArchiveEntry(clip.title, clip.getStartTime(), clip.getDuration(), url)
            entries.append(entry)
        entry = string.join(entries, '\n')
    else:
        entry = getArchiveEntry(context.title, context.getStartTime(), context.getDuration(), url)
    end = getEnd()
    #context.writelog('AsxGen', 'Start is:\n%s' % start)
    #context.writelog('AsxGen', 'Entry is:\n%s' % entry)
    #context.writelog('Asx Gen', 'End is:\n%s' % end)
    print start
    print entry
    print end
    return printed
