from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
from Products.MyMediaManager.General import TimeStamp
import zLOG, sys

def gotattr(obj, atttr):
    return hasattr(obj, attr)

def getDict(obj):
    return obj.__dict__

def getUserPass(user=None):
    if user is not None:
       password = user.getPassword()
    else:
       password = ''
    return password

def getTimeStamp(millis):
    return TimeStamp(millis)

def getUnrestrictedObject(self, path):
    try:        
        return self.unrestrictedTraverse(path)
    except:
        zLOG.LOG('Get unrestricted object', zLOG.ERROR, 'Failed getting object', error=sys.exc_info())

def writeLog(class_name, logtext):
    zLOG.LOG(class_name, zLOG.INFO, logtext)

def getTransitions(self):
    wf_tool = getToolByName(self, 'portal_workflow')
    transitionlist = []
    for id in wf_tool.getWorkflowIds():
        if id != 'collector_issue_workflow':
            wf = wf_tool.getWorkflowById(id)
            if hasattr(wf, 'transitions'):
                if hasattr(wf.transitions, '_mapping'):
                    for transition in wf.transitions._mapping.keys():
                        transition_dict = {}
                        tlist_def = wf.transitions._mapping[transition]
                        tranid = tlist_def.getId()
                        guard = tlist_def.getGuard()
                        a_tlist = {'id': tranid,}
                        name =  getattr(tlist_def, 'actbox_name', None)
                        if name: a_tlist['name'] = name
                        transition_dict['id'] = tranid
                        transition_dict['name'] = name
                        transition_dict['permission'] = guard.permissions
                        transition_dict['roles'] = guard.roles
                        transitionlist.append(transition_dict)

    actionlist = []
    for dict in transitionlist:
        add_new = 1
        for final_dict in actionlist:
            if final_dict['id'] == dict['id']:
                add_new = 0
        if add_new:
            new_dict = {}
            new_dict['id'] = dict['id']
            new_dict['name'] = dict['name']
            permlist = []
            for perm in dict['permission']:
                permlist.append(perm)
            new_dict['permission'] = permlist
            roleslist = []
            for role in dict['roles']:
                roleslist.append(role)
            new_dict['roles'] = roleslist
            actionlist.append(new_dict)

    if not actionlist:
        actionlist = [{'id': 'publish'
                     , 'name': 'Publish'
                     , 'permission': ['Review portal content']
                      }
                    , {'id': 'submit'
                     , 'name': 'Submit'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'retract'
                     , 'name': 'Retract'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'reject'
                     , 'name': 'Reject'
                     , 'permission': ['Review portal content']
                      }]

    return actionlist
