##############################################################################
#    Copyright (C) 2002  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

ADD_FOLDERS_PERMISSION = 'Add portal folders'

import zLOG

#MMMCore
import QuickTimeOndemandServer
from Products.CMFCore.FSDTMLMethod import FSDTMLMethod

#CMF
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerFileExtension, registerDirectory

contentClasses = (  QuickTimeOndemandServer.QuickTimeOndemandServer, )

contentConstructors = ( QuickTimeOndemandServer.addQuickTimeOndemandServer, )

bases = contentClasses

import sys
this_module = sys.modules[ __name__ ]

z_bases = utils.initializeBasesPhase1( bases, this_module )

#zLOG.LOG('RealOndemand init', zLOG.INFO, 'After initialize bases phase 1')

# This is used by a script (external method) that can be run
# to set up MMM in an existing CMF Site instance.
qt_ondemand_globals=globals()

#Make the skins availiable as DirectoryViews
registerDirectory('skins', globals())

# register javascript files as dtml methods
registerFileExtension('js', FSDTMLMethod)

def initialize( context ):

    #context.registerHelp(directory='help')
    #context.registerHelpTitle('Media Manager Help')

    utils.initializeBasesPhase2( z_bases, context )
    #zLOG.LOG('RealOndemand init', zLOG.INFO, 'After initialize bases phase 2')

    from Products.MyMediaManager import all_ftis

    all_ftis.extend(QuickTimeOndemandServer.QuickTimeOndemandServer.factory_type_information)

    utils.ContentInit( 'Quicktime Ondemand Server Content'
                     , content_types=contentClasses
                     , permission=ADD_FOLDERS_PERMISSION
                     , extra_constructors=contentConstructors
                     , fti = ( all_ftis )
                     ).initialize( context )

    #zLOG.LOG('RealOndemand init', zLOG.INFO, 'After content init')
    #return RealOndemandServer.factory_type_information, contentClasses, contentConstructors
